import java.awt.*;
import java.awt.image.PixelGrabber;
import java.awt.image.MemoryImageSource;
import java.awt.image.ImageObserver;

class MosaicFilter
{
	ImageObserver observer;
	Image image;
	int rate;
	int pixels[];

	public MosaicFilter(Image image,int rate)
	{
		this.image = image;
		this.rate = rate;
	}

	// C[W̃UCN
	public Image pixelize(ImageObserver observer)
	{
		this.observer = observer;
		int width = image.getWidth(observer);
		int height = image.getHeight(observer);

		// C[W̕A[gŊ؂邩ǂ
		// ؂ȂƂ́A␳ismod
		int ismod = 0;
		if((width % rate + height % rate) > 0)
		{
			ismod = 1;
		}

		// PixelGrabber̍\z
		pixels = new int[width * height];
		PixelGrabber pg = new PixelGrabber(image,0,0,width,height,pixels,0,width);

		try
		{
			// zɃC[Wi[̂҂
			pg.grabPixels();
		}
		catch(InterruptedException e)
		{
			System.err.println(e.toString());
		}

		// e_To
		for(int i=0;i<pixels.length - (rate * width) * ismod;i+=width * rate)
		{
			for(int j=0;j<width - ((rate - 1) * ismod);j+=rate)
			{
				HandleBasicPixel(i+j);
			}
		}

		MemoryImageSource memory_image = new MemoryImageSource(width,height,pixels,0,width);
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		return(toolkit.createImage(memory_image));
	}

	// _ɂ`̎擾ƃsNZl̍
	protected void HandleBasicPixel(int point)
	{
		int width = image.getWidth(observer);
		int red,green,blue;
		red = green = blue = 0;

		// `̐F̎擾ƍ
		for(int i=0;i<rate;i++)
		{
			for(int j=0;j<rate;j++)
			{
				int current_point = point + i*width + j;

				red += ((pixels[current_point] & 0x00FF0000) >> 16);
				green += ((pixels[current_point] & 0x000FF00) >> 8);
				blue += pixels[current_point] & 0x000000FF;
			}
		}

		// `̐F̕ϒlvZ
		red = (red / (rate*rate)) << 16;
		green = (green / (rate*rate)) << 8;
		blue = blue / (rate*rate);

		// esNZɍlZbg
		for(int i=0;i<rate;i++)
		{
			for(int j=0;j<rate;j++)
			{
				int current_point = point + i*width + j;
				pixels[current_point] = 0xFF000000 | red | green | blue;
			}
		}
	}
}